SystemOrganization addCategory: #Coral!

!UnixProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 14:15'!
newLineInConsole
	
	^String lf! !

!Class methodsFor: '*coral' stamp: 'StephaneDucasse 12/8/2009 17:46'!
< aSubclassSymbol

	^ self subclass: aSubclassSymbol ! !

!Class methodsFor: '*coral' stamp: 'StephaneDucasse 12/8/2009 17:46'!
iv: aStringOfaSingleOrMultipleIV

	^ self addInstVarName: aStringOfaSingleOrMultipleIV! !

!Class methodsFor: '*coral' stamp: 'StephaneDucasse 12/8/2009 17:46'!
package

	^ self category! !

!Class methodsFor: '*coral' stamp: 'StephaneDucasse 12/8/2009 17:46'!
package: aString

	self category: aString! !

!Class methodsFor: '*coral' stamp: 'StephaneDucasse 12/8/2009 17:47'!
shared: aStringOfaSingleOrMultipleClassVar

	^ self addClassVarName: aStringOfaSingleOrMultipleClassVar! !

!MacProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 15:01'!
newLineInConsole
	
	self isUnix 
			ifTrue:[^String lf] 
			ifFalse:[^String cr]! !

TestCase subclass: #CoralClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CoralClassTest methodsFor: 'setup' stamp: 'StephaneDucasse 12/8/2009 17:54'!
setUp

	" does not work ;(
	
	Smalltalk at: #ColorPoint ifPresent: [:each | each removeFromSystem ]
	
	"! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:49'!
testClassDefWithOneIV
	"self debug: #testClassDefWithOneIV"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint 
							iv: 'color' .
	self assert: coloredPointClass superclass = Point.
	self deny: coloredPointClass instVarNames isEmpty.
	self assert: coloredPointClass instVarNames = #('color')! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:55'!
testClassDefWithOneSharedIV
	"self debug: #testClassDefWithOneSharedIV"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint 
							shared: 'DefaultColor'.
	self assert: coloredPointClass superclass = Point.
	self assert: coloredPointClass instVarNames isEmpty.
	self assert: (coloredPointClass classVarNames  includes: 'DefaultColor')! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:50'!
testClassDefWithSeveralIV
	"self debug: #testClassDefWithSeveralIV"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint 
							iv: 'color z'.
	self assert: coloredPointClass superclass = Point.
	self deny: coloredPointClass instVarNames isEmpty.
	self assert: (coloredPointClass instVarNames includes: 'color').
	self assert: (coloredPointClass instVarNames includes: 'z').! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:50'!
testClassDefWithSeveralIVWithSeparateDef
	"self debug: #testClassDefWithSeveralIVWithSeparateDef"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint 
							iv: 'color';
							iv: 'z'.
	self assert: coloredPointClass superclass = Point.
	self deny: coloredPointClass instVarNames isEmpty.
	self assert: (coloredPointClass instVarNames includes: 'color').
	self assert: (coloredPointClass instVarNames includes: 'z').! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:42'!
testSimpleClassDef
	"self debug: #testSimpleClassDef"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint.
	self assert: coloredPointClass superclass = Point.
	self assert: coloredPointClass instVarNames isEmpty! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 21:37'!
testSimpleClassDefWithPackage
	"self debug: #testSimpleClassDefWithPackage"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint
							package: #Box.
	self assert: coloredPointClass superclass = Point.
	self assert: coloredPointClass package = #Box.
	self assert: coloredPointClass category = #Box.
	! !

TestCase subclass: #ScriptInterpreterTest
	instanceVariableNames: 'classNameExecutingScript'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!ScriptInterpreterTest methodsFor: 'utilities' stamp: 'Gwenael.Casaccio 12/10/2008 14:04'!
parseAndInterpretString: aString

	^ ScriptInterpreter parseAndInterpret: (ReadStream on: aString)
	! !

!ScriptInterpreterTest methodsFor: 'runing' stamp: 'ms 1/25/2008 15:34'!
tearDown

	Smalltalk at: #SaBox ifPresent:[:class | class removeFromSystem]! !

!ScriptInterpreterTest methodsFor: 'testing' stamp: 'ms 1/25/2008 15:31'!
testScript
	| interpreter |
	self shouldnt: [interpreter := self parseAndInterpretString: '[
	Object subclass: #SaBox
		instanceVariableNames: ''bob''
		classVariableNames: ''''
		poolDictionaries: ''''
		category: ''SandBox''
	]

	SaBox >> initialize
	[
		<category: ''initialize release''>
		<authorInitials: ''him''>
		bob := ''Script test working''.
	]

	SaBox >> printOn: aStream
	[
		"<category: ''printing''>
		<authorInitials: ''him''>"
		aStream nextPutAll: bob
	]

	SaBox class >> dummy
	[
		<authorInitials: ''him''>
		^3
	]

	[
	SaBox new printString.
	]'] raise: Error.

	self assert: (Smalltalk at: #SaBox ifAbsent:[nil]) notNil.
	self assert: interpreter result = 'Script test working'.! !

!ScriptInterpreterTest methodsFor: 'testing' stamp: 'ms 1/25/2008 15:32'!
testScriptBash
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String lf, '[
			Transcript show: ''Scrip shell 1 working'', String cr
			]'] raise: Error.
	
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String cr, '[
			Transcript show: ''Script shell 2 working'', String cr
			]'] raise: Error.
	
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh'] raise: Error! !

!ScriptInterpreterTest methodsFor: 'testing' stamp: 'ms 1/25/2008 15:34'!
testScriptConsole

	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String lf, '[
			Console print: ''Scrip shell 1 working'', String cr
			]'] raise: Error.
	
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String lf, '[
			Console printError: ''Scrip shell error working'', String cr
			]'] raise: Error.
	
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String lf, '[
			Console read
			]'] raise: Error! !

Object subclass: #Console
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!Console class methodsFor: 'console' stamp: 'StephaneDucasse 12/8/2009 17:59'!
<< aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 16:15'!
closeConsole

	(OSProcess thisOSProcess isKindOf: WindowsProcess) 
		ifTrue: [OSProcess thisOSProcess closeConsole]! !

!Console class methodsFor: 'console' stamp: 'StephaneDucasse 12/8/2009 17:59'!
cr 
	
	^OSProcess thisOSProcess newLineInConsole! !

!Console class methodsFor: 'console' stamp: 'ms 10/5/2006 14:16'!
newLine
	
	^OSProcess thisOSProcess newLineInConsole! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 18:50'!
nextPutAll: aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 16:15'!
openConsole

	(OSProcess thisOSProcess isKindOf: WindowsProcess) 
		ifTrue: [OSProcess thisOSProcess openConsole]! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 18:10'!
print: aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 18:10'!
printError: aStream

	OSProcess thisOSProcess stdErr nextPutAll: aStream! !

!Console class methodsFor: 'console' stamp: 'ms 10/27/2006 13:54'!
printNl: aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream, Console newLine! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 18:34'!
read

	^OSProcess thisOSProcess stdIn readUpToNewLine! !

Object subclass: #CoralInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CoralInstaller commentStamp: 'StephaneDucasse 12/8/2009 18:26' prior: 0!
A CoralInstaller is responsible to install correctly Coral.
!

!CoralInstaller class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 12/8/2009 18:27'!
bashToRecreateInTheFuture

	#(#!! /bin/sh
vm='/Applications/Squeak/Squeak 4.2.1beta1U.app/Contents/MacOS/Squeak VM Opt'
"$vm" "coral.image" $1)! !

Object subclass: #CoralREADME
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CoralREADME commentStamp: '<historical>' prior: 0!
This project lives here:

http://www.squeaksource.com/Coral/

To load Coral, simply evaluate the following in a fresh image:

ScriptLoader new installer ss project: 'Coral'; install: 'LoadCoral'.

For more information (workspace documentation on class side), just evaluate:

self initialize
!

!CoralREADME class methodsFor: 'comment' stamp: 'StephaneDucasse 12/8/2009 18:28'!
faq
	^ '"Q How does the image know how to interpret scripts?
A ScriptInterpreter class>>initialize registers itself as a startup class

Q Why is CoralLoader in a separate package?
A So it doesn''t try to reload itself when it loads Coral.
"'! !

!CoralREADME class methodsFor: 'initialization' stamp: 'on 2/25/2009 12:15'!
initialize
	super initialize.
	
	self openWorkspaceLabeled: 'READ ME' withContents: self readMe.
	self openWorkspaceLabeled: 'TO DO' withContents: self todo.
	self openWorkspaceLabeled: 'FAQ' withContents: self faq.! !

!CoralREADME class methodsFor: 'private' stamp: 'StephaneDucasse 9/3/2009 17:45'!
openWorkspaceLabeled: label withContents: contents
	| info |
	info := Workspace new.
	info contents: contents.
	info openLabel: label! !

!CoralREADME class methodsFor: 'comment' stamp: 'StephaneDucasse 12/8/2009 18:29'!
readMe
	^ '"INSTRUCTIONS

TO REVISED.... 





[We assume you are on a Mac -- you will need to adapt these instructions for other platforms ...]

- Save this image as ''coral.image''

- Install the following Squeak VM in /Applications/Squeak:

http://homepage.mac.com/johnmci/.Public/Squeak%204.2.1beta1U.app.zip

- Install Rio (File-Base) for simpler file management

Installer ss project: ''Rio'' ; install: ''File-Kernel'' ;install: ''File-Base''.

- Save the following shell script as ''coral.sh'' and make it executable:

''coral.sh'' asFile contents: ''#!! /bin/sh
vm=''''/Applications/Squeak/Squeak 4.2.1beta1U.app/Contents/MacOS/Squeak VM Opt''''
"$vm" -headless coral.image $1''

- Save the following script into the file ''hello.st''

''hello.st'' asFile contents: ''[
	Console print: ''''Coral is working'''', String lf.
	Console print: ''''Yahoo!!''''
]''

Now you should be able to run the coral script from the command line as follows:

./coral.sh hello.st

----

Another script example:

''rio-test.st'' asFile contents: ''[
	Object subclass: #SaBox
		instanceVariableNames: ''''bob''''
		classVariableNames: ''''''''
		poolDictionaries: ''''''''
		category: ''''SandBox''''
]

SaBox>>convertToFiles: aClass inDirectory: rootDir
[
	"a dummy example that convert a class in a file hierarchy"
	| classDir categoryNames |
	classDir := (rootDir / aClass asString) mkdir.
	categoryNames := aClass organization categories collect: [ :aCategory | aCategory asString ].
	categoryNames do: [ :aCategoryName | | protocolDir | 
		protocolDir := (classDir / aCategoryName) mkdir. 
		(aClass methodsInCategory: aCategoryName) do: [ :aSelector |
			(protocolDir / (aSelector asFileName replaceAll: $: with: $_)) asFile contents: (aClass sourceCodeAt: aSelector) 
		]
	].
	^classDir
]


[
	SaBox new convertToFiles: Object inDirectory: Directory home.
	Console print: ''''The directory '''', Directory home path, ''''/Object has been created''''
]''

"
'! !

!CoralREADME class methodsFor: 'comment' stamp: 'StephaneDucasse 12/8/2009 18:36'!
todo
	^ '"TO DO ITEMS
- clean up dead code (current)
- check extensions made in previous package 
- merge to get back the ancestors
- check ScriptInterpreter?? 
	Do we need to create a class for a script
	How do we store a execution component:  [ ] and list of them [ ]
	for now we can only manipulate scripts outside the image. 

- refresh the readme
- make sure we can pass a script
- remove dependencies on fileman

- support for #!! notation (done)
- installer for #!! script runner

- filename or rio for file
- debug mode for scripts (escape to image)
- passing arguments to scripts
- pipes and filters (stdin and stdout)
- redirecting Smalltalk errors to stderr
- evaluating external Unix commands (cf. backtick commands)
- multi-=platform support (installers?)
- environment to develop and debug scripts (extend class browser?)
- demo scripts
- tutorial"'! !

Object subclass: #SandBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!SandBox methodsFor: 'as yet unclassified' stamp: 'TestRunner 12/8/2009 17:50'!
red
	^ self blue! !

Object subclass: #ScriptInterpreter
	instanceVariableNames: 'nodes results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

ScriptInterpreter class
	instanceVariableNames: 'fileName'!

ScriptInterpreter class
	instanceVariableNames: 'fileName'!

!ScriptInterpreter class methodsFor: 'old' stamp: 'on 2/25/2009 14:47'!
creatScriptClass: string
	^ScriptInterpreter subclass: string asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Coral-Interpreting'! !

!ScriptInterpreter class methodsFor: 'file list services' stamp: 'ms 10/28/2006 23:49'!
fileExecuteScript: fullName

	| fileName fileNameStream class |
	fullName ifNil: [^ Beeper beep].
	fileNameStream := WriteStream on: String new.
	(FmFileEntry pathName: fullName) name 
			detect:[:each | 
				each = $. ifFalse: [fileNameStream nextPut: each].
				each = $.].
	fileName := fileNameStream contents capitalized.
	class := self creatScriptClass: fileName.
	Cursor read showWhile: [
		self parseAndInterpret: (FileStream readOnlyFileNamed: fullName) in: class]! !

!ScriptInterpreter class methodsFor: 'file list services' stamp: 'on 2/25/2009 14:47'!
fileReaderServicesForFile: fullName suffix: suffix
	
	^ (suffix = 'sct') | (suffix = 'sff') | (suffix = 'coral')
		ifTrue:[{self serviceScriptFile}]
		ifFalse:[#()]! !

!ScriptInterpreter class methodsFor: 'runing' stamp: 'ms 12/21/2006 15:43'!
fullName
	
	^fileName! !

!ScriptInterpreter class methodsFor: 'initialize-release' stamp: 'ms 12/21/2006 15:57'!
initialize
	"self initialize"	
	Smalltalk addToStartUpList: self.
	FileList registerFileReader: self.
	Preferences setPreference: #readDocumentAtStartup toValue: false! !

!ScriptInterpreter class methodsFor: 'old' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
interpret: nodes

	^self new nodes: nodes; interpret; yourself! !

!ScriptInterpreter class methodsFor: 'old' stamp: 'ms 10/29/2006 00:15'!
interpret: anCol in: aClass

	^self new interpret: anCol in: aClass; yourself! !

!ScriptInterpreter class methodsFor: 'old' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
jumpIfBashScript: aStream
	
	(aStream peek =$#) ifTrue: [
		[| aChar | 
		 aChar := aStream next.
		(aChar = nil) or: [(aChar = Character lf) or: [aChar = Character cr]]] whileFalse].
	^aStream! !

!ScriptInterpreter class methodsFor: 'old' stamp: 'StephaneDucasse 12/8/2009 18:21'!
oldFileExecuteScript: fullName

	| fileName fileNameStream class |
	fullName ifNil: [^ Beeper beep].
	fileNameStream := WriteStream on: String new.
	(#FmFileEntry pathName: fullName) name 
			detect:[:each | 
				each = $. ifFalse: [fileNameStream nextPut: each].
				each = $.].
	fileName := fileNameStream contents capitalized.
	class := self creatScriptClass: fileName.
	Cursor read showWhile: [
		self parseAndInterpret: (FileStream readOnlyFileNamed: fullName) in: class]! !

!ScriptInterpreter class methodsFor: 'script interpreter' stamp: 'StephaneDucasse 12/8/2009 18:24'!
parse: aStream
		
	^ PPCoralParser parse: aStream! !

!ScriptInterpreter class methodsFor: 'old' stamp: 'on 2/25/2009 14:46'!
parseAndInterpret: aStream 
	^ self interpret: (CoralParser parseScript: (self jumpIfBashScript: aStream))! !

!ScriptInterpreter class methodsFor: 'old' stamp: 'on 2/25/2009 14:46'!
parseAndInterpret: aStream in: class 
	^ self 
		interpret: (CoralParser 
				parseScript: (self jumpIfBashScript: aStream)
				in: class)
		in: class! !

!ScriptInterpreter class methodsFor: 'file list services' stamp: 'StephaneDucasse 12/8/2009 18:22'!
serviceScriptFile
	
	^ SimpleServiceEntry 
		provider: self 
		label: 'execute a script'
		selector: #fileExecuteScript:
		description: 'execute a script'
		buttonLabel: 'Do It'! !

!ScriptInterpreter class methodsFor: 'system startup' stamp: 'StephaneDucasse 12/8/2009 18:22'!
startUp

	"Smalltalk addToStartUpList: self"
	| script |
	script := ((SmalltalkImage current getSystemAttribute: 2) ifNil:['']) convertFromSystemString.
	script isEmpty ifFalse:[
		[ScriptInterpreter parse: (FileStream readOnlyFileNamed: script)] 
			on: Exception
			do: [ :ex | 
				(ex isKindOf: InMidstOfFileinNotification) 
					ifTrue:[ ex resume: false ]
					ifFalse: [
				Smalltalk
					logError: ex printString
					inContext: thisContext
					to: 'CoralDebug.log'.
				Console printNl: ex printString]].
		Console printNl: ''.
		Smalltalk quitPrimitive]! !

!ScriptInterpreter methodsFor: 'accessing' stamp: 'ms 8/28/2006 12:20'!
compiledMethods
	^compiledMethods ifNil: [compiledMethods := OrderedCollection new]! !

!ScriptInterpreter methodsFor: 'interpreter' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
interpret

	results := nodes collect: [:each | each execute]! !

!ScriptInterpreter methodsFor: 'interpreting' stamp: 'ms 10/29/2006 00:16'!
interpret: aCol
	
	Console openConsole.
	aCol do: [:each | self compiledMethods add: (each executeIt)].
	(class canPerform: #run) ifFalse:[self error:'Script must content a run method'].
	class new perform: #run.
	Console closeConsole! !

!ScriptInterpreter methodsFor: 'interpreting' stamp: 'ms 10/29/2006 00:08'!
interpret: aCol in: aClass
	
	class := aClass.
	self interpret: aCol! !

!ScriptInterpreter methodsFor: 'accessing' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
nodes
	^ nodes! !

!ScriptInterpreter methodsFor: 'accessing' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
nodes: anObject
	nodes := anObject! !

!ScriptInterpreter methodsFor: 'accessing' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
result

	^results last! !

!Utilities class methodsFor: '*coral' stamp: 'ms 10/2/2006 22:53'!
changeStampWithInitials: aString
	"Answer a string to be pasted into source code to mark who changed it and when."
	^ aString , ' ' , Date today mmddyyyy, ' ',
		((String streamContents: [:s | Time now print24: true on: s]) copyFrom: 1 to: 5)! !

PPCompositeParser subclass: #PPCoralGrammar
	instanceVariableNames: 'block method program methodHeader methodBody bang smalltalk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!PPCoralGrammar class methodsFor: 'accessing' stamp: 'lr 12/7/2009 13:53'!
ignoredNames
	^ super ignoredNames , #(smalltalk)! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/29/2009 10:34'!
bang
	^ '#!!' asParser , (#newline asParser negate) star! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/28/2009 18:25'!
block
	^ self smalltalk block! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/28/2009 18:22'!
method
	^ methodHeader , methodBody! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/29/2009 10:39'!
methodBody
	^ $[ asParser token , self smalltalk	 pragmas , self smalltalk temporaries , self smalltalk pragmas , self smalltalk statements , $] asParser token! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/29/2009 10:47'!
methodHeader
	^ (self smalltalk identifier token , 'class' asParser token optional) token , '>>' asParser token , self smalltalk methodDeclaration! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/28/2009 18:38'!
program
	^ bang optional , (block / method) star! !

!PPCoralGrammar methodsFor: 'composition' stamp: 'lr 11/28/2009 18:48'!
smalltalk
	^ smalltalk ifNil: [ smalltalk := PPSmalltalkGrammar new ]! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/28/2009 18:16'!
start
	^ program end! !

PPCoralGrammar subclass: #PPCoralParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!PPCoralParser class methodsFor: 'as yet unclassified' stamp: 'TestRunner 12/7/2009 16:09'!
todo

	"use last version of OSProcess"
	"merge PetitCoral and Coral"
	"Create a configuration to load everything in one click"
	
	"DONE After"
	"for Method
	aClass compile: aMethodNode formattedCode

for Block
	Compiler evaluate: aSequenceNode formattedCode"
	
	"or formattedString"! !

!PPCoralParser methodsFor: 'productions' stamp: 'TestRunner 12/7/2009 16:54'!
block
	^ super block ==> [ :nodes |
		"waiting for the new compiler. For the moment we ask the old compiler to recompile everything"
		Compiler evaluate:  nodes body formattedCode	
		]
	
! !

!PPCoralParser methodsFor: 'productions' stamp: 'TestRunner 12/7/2009 23:28'!
method
	^ super method ==> [ :nodes |
		"waiting for the new compiler. For the moment we ask the old compiler to recompile everything"
		(Smalltalk classNamed: nodes first first value)
			compile: 
			(nodes first third
				propertyAt: #class put: (Smalltalk classNamed: nodes first first value);
				pragmas: nodes second second , nodes second fourth;
				body: (RBSequenceNode 
					temporaries: nodes second third
					statements: nodes second fifth);
				yourself) formattedCode
			]! !

!PPCoralParser methodsFor: 'productions' stamp: 'TestRunner 12/7/2009 16:20'!
program
	^ super program ==> #second! !

!PPCoralParser methodsFor: 'composition' stamp: 'lr 12/7/2009 13:52'!
smalltalk
	^ smalltalk ifNil: [ smalltalk := PPSmalltalkParser new ]! !

!WindowsProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 14:16'!
newLineInConsole
	
	^String cr, String lf! !

!OS2Process methodsFor: '*coral' stamp: 'ms 10/5/2006 14:14'!
newLineInConsole
	
	^String cr, String lf! !

PPSmalltalkGrammarTests subclass: #PPCoralGrammarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

PPCoralGrammarTest subclass: #PPCoralCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!PPCoralCompilerTest methodsFor: 'accessing' stamp: 'StephaneDucasse 12/8/2009 17:55'!
parserClass
	^ PPCoralParser! !

!PPCoralCompilerTest methodsFor: 'testing' stamp: 'StephaneDucasse 12/8/2009 17:55'!
testABlock
	"self debug: #testABlock"
	
	| res |
	res := PPCoralParser parse: '[ 1 + 2]'.
	self assert: res = #(3).
! !

!PPCoralCompilerTest methodsFor: 'testing' stamp: 'StephaneDucasse 12/8/2009 17:55'!
testAnotherBlock
	"self debug: #testAnotherBlock"
	
	self assert: (PPCoralParser parse: '[Beeper beep] ') = {Beeper}						
	! !

!PPCoralCompilerTest methodsFor: 'testing' stamp: 'StephaneDucasse 12/8/2009 17:55'!
testBangProgram
	"self debug: #testBangProgram"
	
	self assert: 
		(PPCoralParser parse: '#!!/bin/usr/coralNegated 
	SandBox>>blue 
	    [^ 2]
	
	SandBox>>red 
	    [^ self blue]
	
	[SandBox new red = 2]' 
		) = #(blue red true)
	! !

!PPCoralCompilerTest methodsFor: 'testing' stamp: 'StephaneDucasse 12/8/2009 17:55'!
testDefineAMethod
	"self debug: #testDefineAMethod"
	
	PPCoralParser parse: 'SandBox>>blue [^ 2]'.
	self assert: SandBox new blue = 2.
	SandBox removeSelector: #blue.! !

!PPCoralCompilerTest methodsFor: 'testing' stamp: 'StephaneDucasse 12/7/2009 17:02'!
testFullProgram
	"self debug: #testFullProgram"

	super testFullProgram ! !

!PPCoralCompilerTest methodsFor: 'testing' stamp: 'TestRunner 12/7/2009 23:27'!
testMethodUnary1
	"self debug: #testMethodUnary1"

	super testMethodUnary1.
	self assert: (result = #coralNegated)
	"
	self assert: result isMethod.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1.
	self assert: result body statements first isReturn.
	self assert: result body statements first value isMessage.
	self assert: result body statements first value receiver isLiteral.
	self assert: result body statements first value selector = #-.
	self assert: result body statements first value arguments size = 1.
	self assert: result body statements first value arguments first isVariable
	"! !

!PPCoralGrammarTest methodsFor: 'accessing' stamp: 'StephaneDucasse 12/8/2009 17:56'!
parserClass
	^ PPCoralGrammar! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'StephaneDucasse 12/7/2009 15:00'!
testBang
	"self debug: #testBang"

	self 
		parse: '#!!/usr/bin/work '
		rule: #program.
		
	self 
		parse: '#!!/usr/bin/work   '
		rule: #program.
		
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'TestRunner 12/7/2009 16:59'!
testBangFullProgram
	"self debug: #testBangFullProgram"

	self 
		parse: '#!!/bin/usr/
		[Beeper beep]
		
				Point>> foo 
					[  1 + 2]
				
				Point>> foo2 
					[ ^ 1 + 2]
				
				[Beeper beep]'
		rule: #program
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'TestRunner 12/7/2009 15:00'!
testBangNoSpace
	"self debug: #testBangNoSpace"

	self 
		parse: '#!!/usr/bin/work'
		rule: #program
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'sd 10/3/2009 13:27'!
testBlock
	"self debug: #testBlock"

	self 
		parse: ' [Beeper beep]'
		rule: #block
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'sd 10/3/2009 13:28'!
testFullProgram
	"self debug: #testFullProgram"

	self 
		parse: ' [Beeper beep]
		
				Point>> foo 
					[  1 + 2]
				
				Point>> foo2 
					[ ^ 1 + 2]
				
				[Beeper beep]'
		rule: #program
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'TestRunner 12/7/2009 16:59'!
testMethod
	"self debug: #testMethod"

	self 
		parse: 'SandBox>>blue [^ 2]'
		rule: #program
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 17:10'!
testMethodBinary1
	"self debug: #testMethodBinary1"

	self 
		parse: 'Point>>+ arg [^ self + arg]'
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 17:10'!
testMethodBinary2
	"self debug: #testMethodBinary2"

	self 
		parse: '     Point    >>   + arg [^ self + arg ]'
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 17:11'!
testMethodBinary3
	"self debug: #testMethodBinary3"

	self 
		parse: '     Point    >>   + arg 
							[^ self + arg ]   '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 17:11'!
testMethodBinary4
	"self debug: #testMethodBinary4"

	self 
		parse:  '     Point  class  >>   + arg 
							[^ self + arg ]   '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 17:12'!
testMethodKeyword1
	"self debug: #testMethodKeyword1"

	self 
		parse: 'Point>>coralSetX: x y:y
					 [^ self class new setX: x ; setY: y ]'
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 17:13'!
testMethodKeyword2
	"self debug: #testMethodKeyword2"

	self 
		parse: 'Point >>  coralSetX: x y:y
					 [^ self class new setX: x ; setY: y ] '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 17:13'!
testMethodKeyword3
	"self debug: #testMethodKeyword3"

	self 
		parse: '   Point >>  coralSetX: x y:        
		   y
					 [^ self class new setX: x ; setY: y ] '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 17:13'!
testMethodKeyword4
	"self debug: #testMethodKeyword4"

	self 
		parse: '   Point class >>  coralNewX: x y:        
		   y
					 [^ self  new setX: x ; setY: y ] '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'TestRunner 12/7/2009 16:38'!
testMethodUnary1
	"self debug: #testMethodUnary1"

	self 
		parse: 'Point>>coralNegated[^0-self]'
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'TestRunner 12/7/2009 16:32'!
testMethodUnary2
	"self debug: #testMethodUnary2"

	self 
		parse: '   Point  >>  coralNegated   [ ^ 0 - self ]  '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'TestRunner 12/7/2009 16:30'!
testMethodUnary3
	"self debug: #testMethod3"

	"for now let us test the following"
	self 
		parse: '   Point >> coralNegated [^ 0 - self]     '
		rule: #method
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'sd 12/7/2009 13:45'!
testMethodUnaryClass4
	"self debug: #testMethodUnaryClass4"

	"for now let us test the following"
	self 
		parse: '   Point class >> coralNegated [^ 0 - self]     '
		rule: #program
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'sd 10/3/2009 13:25'!
testProgram
	"self debug: #testProgram"

	self 
		parse: ' [Beeper beep]'
		rule: #program
		
	! !

!PPCoralGrammarTest methodsFor: 'testing' stamp: 'sd 10/3/2009 13:26'!
testProgramAsASingleBlock
	"self debug: #testProgram"

	self 
		parse: ' [Beeper beep]'
		rule: #program
		
	! !
CoralREADME initialize!
ScriptInterpreter initialize!
